/**
 * *************************************************************************************************************
 * @file BoardCfg.h
 * @author BH_CodeGenerator
 * @version 0.1
 * @date 2022-04-01
 * @warning <!--auto generated by Tools, do not modify or add anything, otherwise, your change will be lost!!! -->
 * @brief all the functions prototypes for BoardCfg firmware library
 * MCU / CFG Ver. :BH67F2472/1.5
 * Version = 1.0.0

 * *************************************************************************************************************
 *  @attention
 *
 *  Firmware Disclaimer Information
 *
 *  1. The customer hereby acknowledges and agrees that the program technical documentation, including the
 *     code, which is supplied by BEST HEALTH ELECTRONIC Inc., (hereinafter referred to as BestHealth) is the
 *     proprietary and confidential intellectual property of BestHealth, and is protected by copyright law and
 *     other intellectual property laws.
 *
 *  2. The customer hereby acknowledges and agrees that the program technical documentation, including the
 *     code, is confidential information belonging to BestHealth, and must not be disclosed to any third parties
 *     other than BestHealth and the customer.
 *
 *  3. The program technical documentation, including the code, is provided and for customer reference
 *     only. After delivery by BestHealth, the customer shall use the program technical documentation, including
 *     the code, at their own risk. BestHealth disclaims any expressed, implied or statutory warranties, including
 *     the warranties of merchantability, satisfactory quality and fitness for a particular purpose.
 *
 *  <h2><center>Copyright (C) BEST HEALTH ELECTRONIC Inc. All rights reserved</center></h2>
 */
#ifndef _BOARD_CFG_H_
#define _BOARD_CFG_H_

#include "..\driver\stdbool.h"
// Board: BH67F2472_EVM_2.0
#include "..\driver\Gpio.h"

// clang-format off
//-----------system clock config----------
// #define SUPPORT_ISP
// #define _HXT_
// #define  _LXT_   //!< OCDS debug Mode must commented
// if SYS_CLOCK_FREQ >= 12MHz，VDD must > 2.7V
// if SYS_CLOCK_FREQ >= 16MHz，VDD must > 3.3V
// Please refer to the specifications for details
#define FH_CLOCK_FREQ 8000000    //!< 設置 MCU 高速频率，目前支援設置為 4000000,8000000,12000000
#define SYS_CLOCK_FREQ FH_CLOCK_FREQ    //!< 設置系統頻率，目前支援設置為 4000000,8000000,12000000

//-------------UART0 config-----------------
#define UART0_BAUD_RATE 9600    //!< 300(Only 4M),1200,2400,4800,9600,19200,38400(Only 8M),57600(Only 12M),250000
#define PIN_TX0_PC6             // PC0,PC6
#define PIN_RX0_PC0             // PC0
//-------------UART1 config-----------------
#define UART1_BAUD_RATE 9600    //!< 300(Only 4M),1200,2400,4800,9600,19200,38400(Only 8M),57600(Only 12M),250000
#define PIN_TX1_PC2             // PC1,PC2
#define PIN_RX1_PC1             // PC1
//-------------SPIA config-----------------
#define PIN_SCSA_PD3    // PD3
#define PIN_SCKA_PD0    // PD0
#define PIN_SDIA_PD1    // PD1
#define PIN_SDOA_PD2    // PD2
//-------------SPI config-----------------
#define PIN_SCS0_PA1    // PA1
#define PIN_SCK0_PA3    // PA3
#define PIN_SDI0_PC0    // PC0
#define PIN_SDO0_PC6    // PC6
//-------------SPI config-----------------
#define PIN_SCS1_PC5    // PC5
#define PIN_SCK1_PB7    // PB7
#define PIN_SDI1_PC1    // PC1
#define PIN_SDO1_PC2    // PC2
//-------------I2c config-----------------
#define PIN_SDA0_PC0    // PC0
#define PIN_SCL0_PA3    // PA3
//-------------I2c Salve config-----------------
#define PIN_SDA1_PC1    // PC1
#define PIN_SCL1_PB7    // PB7
//-------------I2C Master config -------------
#define PIN_MASTER_I2C_SDA_P pc
#define PIN_MASTER_I2C_SDA_N 0
#define PIN_MASTER_I2C_SCL_P pa
#define PIN_MASTER_I2C_SCL_N 3

//-------------PTM0 config-----------------

#define PIN_PTCK0_PD2    // PD2
#define PIN_PTP0_PB4     // PB4,PD0
#define PIN_PTP0B_PB5    // PB5,PD1
//-------------PTM1 config-----------------

#define PIN_PTCK1_PE5    // PE5
#define PIN_PTP1_PE3     // PE3
#define PIN_PTP1B_PE4    // PE4
//-------------STM config-----------------

#define PIN_STCK_PE2    // PE2
#define PIN_STP_PE0     // PE0
#define PIN_STPB_PE1    // PE1
//-------------ATM config-----------------
#define PIN_ATCK_PC5    // PC5
#define PIN_ATP_PA5     // PA5,PD4
#define PIN_ATPB_PA4    // PA4,PD5
//-------------INT PIN config-----------------
#define PIN_INT0_PA6    // PA6
#define PIN_INT1_PA7    // PA7
#define PIN_INT2_PC2    // PC2
#define PIN_INT3_PC1    // PC1


#endif