/**
 * *************************************************************************************************************
 * @file Reset.h
 * @author BH_CodeGenerator
 * @version 0.1
 * @date 2022-04-01
 * @warning <!--auto generated by Tools, do not modify or add anything, otherwise, your change will be lost!!! -->
 * @brief all the functions prototypes for Reset firmware library
 * MCU / CFG Ver. :BH67F2472/1.5
 * Version = 1.0.0

 * *************************************************************************************************************
 *  @attention
 *
 *  Firmware Disclaimer Information
 *
 *  1. The customer hereby acknowledges and agrees that the program technical documentation, including the
 *     code, which is supplied by BEST HEALTH ELECTRONIC Inc., (hereinafter referred to as BestHealth) is the
 *     proprietary and confidential intellectual property of BestHealth, and is protected by copyright law and
 *     other intellectual property laws.
 *
 *  2. The customer hereby acknowledges and agrees that the program technical documentation, including the
 *     code, is confidential information belonging to BestHealth, and must not be disclosed to any third parties
 *     other than BestHealth and the customer.
 *
 *  3. The program technical documentation, including the code, is provided and for customer reference
 *     only. After delivery by BestHealth, the customer shall use the program technical documentation, including
 *     the code, at their own risk. BestHealth disclaims any expressed, implied or statutory warranties, including
 *     the warranties of merchantability, satisfactory quality and fitness for a particular purpose.
 *
 *  <h2><center>Copyright (C) BEST HEALTH ELECTRONIC Inc. All rights reserved</center></h2>
 */
/* Define to prevent recursive inclusion -------------------------------------------------------------------*/
#ifndef _RESET_MCU_H_
#define _RESET_MCU_H_

/* Includes ------------------------------------------------------------------------------------------------*/
#include "stdbool.h"
#include "BH67F2472.h"

/* Exported types ------------------------------------------------------------------------------------------*/

/* Exported functions --------------------------------------------------------------------------------------*/
// clang-format off
#define ResetMcu_LvrReg()               { _lvrc = 0x00;}   //!< 软件控制 LVR 暂存器使 MCU 复位,复位后会置位 _lrf
#define IsDetectedFlag_LvrRegResetMcu   _lrf == true
#define ClearFlag_LvrRegResetMcu()      {_lrf = false;}

#define ResetMcu_RstReg()               { _rstc = 0x00;}   //!< 软件控制 rstc 暂存器使 MCU 复位, 复位后会置位 _rstf
#define IsDetectedFlag_RstRegResetMcu   _rstf == true
#define ClearFlag_RstRegResetMcu()      {_rstf = false;}

#define ResetMcu_WdtReg()               { _wdtc = 0x00;}   //!< 软件控制 wdtc 暂存器使 MCU 复位, 复位后会置位 _wrf
#define IsDetectedFlag_WdtRegResetMcu   _wrf == true
#define ClearFlag_WdtRegResetMcu()      {_wrf = false;}

#define ResetMcu_IapReg()               { _fc1 = 0x55;}   //!< 软件控制 fc1 暂存器使 MCU 复位, 复位后会置位
// clang-format on

#endif