/**
 * *************************************************************************************************************
 * @file Rtc.h
 * @author BH_CodeGenerator
 * @version 0.1
 * @date 2022-04-01
 * @warning <!--auto generated by Tools, do not modify or add anything, otherwise, your change will be lost!!! -->
 * @brief all the functions prototypes for Rtc firmware library
 * MCU / CFG Ver. :BH67F2472/1.5
 * Version = 1.0.0

 * *************************************************************************************************************
 *  @attention
 *
 *  Firmware Disclaimer Information
 *
 *  1. The customer hereby acknowledges and agrees that the program technical documentation, including the
 *     code, which is supplied by BEST HEALTH ELECTRONIC Inc., (hereinafter referred to as BestHealth) is the
 *     proprietary and confidential intellectual property of BestHealth, and is protected by copyright law and
 *     other intellectual property laws.
 *
 *  2. The customer hereby acknowledges and agrees that the program technical documentation, including the
 *     code, is confidential information belonging to BestHealth, and must not be disclosed to any third parties
 *     other than BestHealth and the customer.
 *
 *  3. The program technical documentation, including the code, is provided and for customer reference
 *     only. After delivery by BestHealth, the customer shall use the program technical documentation, including
 *     the code, at their own risk. BestHealth disclaims any expressed, implied or statutory warranties, including
 *     the warranties of merchantability, satisfactory quality and fitness for a particular purpose.
 *
 *  <h2><center>Copyright (C) BEST HEALTH ELECTRONIC Inc. All rights reserved</center></h2>
 */
/* Define to prevent recursive inclusion -------------------------------------------------------------------*/
#ifndef _RTC_H_
#define _RTC_H_

/* Includes ------------------------------------------------------------------------------------------------*/
#include <stdint.h>

/* Exported types ------------------------------------------------------------------------------------------*/
struct TimeInfor {
    uint16_t year;    //!<* 年份
    uint8_t month;    //!<* 月份
    uint8_t date;     //!<* 日期
    uint8_t hour;     //!<* 小时
    uint8_t min;      //!<* 分钟
    uint8_t sec;      //!<* 秒钟
    uint32_t unix;    //!<* 时间戳
};

/* Exported Variables --------------------------------------------------------------------------------------*/
extern struct TimeInfor time;

/* Exported functions --------------------------------------------------------------------------------------*/
void Rtc_Enable(void);
void Rtc_Disable(void);
void Rtc_TimeUnixAddIsr(void);
void UnixToBeiJinTime(struct TimeInfor *time);
void BeiJinTimeToUnix(struct TimeInfor *time);

#endif